package de.mdelab.mlsdm.diagram.custom.actions;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlcore.ui.diagrams.CustomAbstractActionDelegate;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;

public class RemoveActivityFinalNodeReturnValueExpressionAction extends CustomAbstractActionDelegate
{
	ActivityFinalNode	finalNode;

	@Override
	protected void doRun(IProgressMonitor progressMonitor)
	{
		ActivityFinalNodeEditPart finalNodeEditPart = ((ActivityFinalNodeEditPart) getStructuredSelection().getFirstElement());

		finalNode = (ActivityFinalNode) ((View) finalNodeEditPart.getModel()).getElement();

		AbstractTransactionalCommand command = new AbstractTransactionalCommand(finalNodeEditPart.getEditingDomain(), "Edit Expression",
				null)
		{

			@Override
			protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
			{
				//finalNode.setReturnValue(null);

				return CommandResult.newOKCommandResult();
			}
		};

		execute(command);
	}
}
