package de.mdelab.mlsdm.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEdgeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeExpressionFigureCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeExpressionFigureCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeName2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeName2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPattern2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternName2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternConstraintsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternConstraintsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel10EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel11EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel12EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel13EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel15EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel4EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel5EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel6EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel7EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel8EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel9EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabelEditPart;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class MlsdmVisualIDRegistry
{

	/**
	 * @generated
	 */
	private static final String	DEBUG_KEY	= "de.mdelab.mlsdm.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view)
	{
		if (view instanceof Diagram)
		{
			if (ActivityEditPart.MODEL_ID.equals(view.getType()))
			{
				return ActivityEditPart.VISUAL_ID;
			}
			else
			{
				return -1;
			}
		}
		return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view)
	{
		View diagram = view.getDiagram();
		while (view != diagram)
		{
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null)
			{
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type)
	{
		try
		{
			return Integer.parseInt(type);
		}
		catch (NumberFormatException e)
		{
			if (Boolean.TRUE.toString().equalsIgnoreCase(Platform.getDebugOption(DEBUG_KEY)))
			{
				MlsdmDiagramEditorPlugin.getInstance().logError("Unable to parse view type as a visualID number: " + type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID)
	{
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement)
	{
		if (domainElement == null)
		{
			return -1;
		}
		if (MlsdmPackage.eINSTANCE.getActivity().isSuperTypeOf(domainElement.eClass()) && isDiagram((Activity) domainElement))
		{
			return ActivityEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement)
	{
		if (domainElement == null)
		{
			return -1;
		}
		String containerModelID = de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry.getModelID(containerView);
		if (!ActivityEditPart.MODEL_ID.equals(containerModelID))
		{
			return -1;
		}
		int containerVisualID;
		if (ActivityEditPart.MODEL_ID.equals(containerModelID))
		{
			containerVisualID = de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry.getVisualID(containerView);
		}
		else
		{
			if (containerView instanceof Diagram)
			{
				containerVisualID = ActivityEditPart.VISUAL_ID;
			}
			else
			{
				return -1;
			}
		}
		switch (containerVisualID)
		{
			case ActivityEditPart.VISUAL_ID:
				if (MlsdmPackage.eINSTANCE.getActivityFinalNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ActivityFinalNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getDecisionMergeNode().isSuperTypeOf(domainElement.eClass()))
				{
					return DecisionMergeNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getExpressionActivityNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ExpressionActivityNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getFlowFinalNode().isSuperTypeOf(domainElement.eClass()))
				{
					return FlowFinalNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getForkJoinNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ForkJoinNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getInitialNode().isSuperTypeOf(domainElement.eClass()))
				{
					return InitialNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getStoryNode().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryNodeEditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getStructuredNode().isSuperTypeOf(domainElement.eClass()))
				{
					return StructuredNodeEditPart.VISUAL_ID;
				}
				break;
			case StructuredNodeEditPart.VISUAL_ID:
				if (MlsdmPackage.eINSTANCE.getDecisionMergeNode().isSuperTypeOf(domainElement.eClass()))
				{
					return DecisionMergeNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getExpressionActivityNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ExpressionActivityNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getFlowFinalNode().isSuperTypeOf(domainElement.eClass()))
				{
					return FlowFinalNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getForkJoinNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ForkJoinNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getInitialNode().isSuperTypeOf(domainElement.eClass()))
				{
					return InitialNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getStoryNode().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getStructuredNode().isSuperTypeOf(domainElement.eClass()))
				{
					return StructuredNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getActivityFinalNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ActivityFinalNode2EditPart.VISUAL_ID;
				}
				break;
			case StructuredNode2EditPart.VISUAL_ID:
				if (MlsdmPackage.eINSTANCE.getDecisionMergeNode().isSuperTypeOf(domainElement.eClass()))
				{
					return DecisionMergeNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getExpressionActivityNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ExpressionActivityNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getFlowFinalNode().isSuperTypeOf(domainElement.eClass()))
				{
					return FlowFinalNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getForkJoinNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ForkJoinNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getInitialNode().isSuperTypeOf(domainElement.eClass()))
				{
					return InitialNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getStoryNode().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getStructuredNode().isSuperTypeOf(domainElement.eClass()))
				{
					return StructuredNode2EditPart.VISUAL_ID;
				}
				if (MlsdmPackage.eINSTANCE.getActivityFinalNode().isSuperTypeOf(domainElement.eClass()))
				{
					return ActivityFinalNode2EditPart.VISUAL_ID;
				}
				break;
			case ExpressionActivityNodeExpressionFigureCompartmentEditPart.VISUAL_ID:
				if (MlexpressionsPackage.eINSTANCE.getMLStringExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return MLStringExpressionEditPart.VISUAL_ID;
				}
				if (MlcallactionsPackage.eINSTANCE.getCallActionExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return CallActionExpression2EditPart.VISUAL_ID;
				}
				break;
			case StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID:
				if (MlstorypatternsPackage.eINSTANCE.getStoryPattern().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryPatternEditPart.VISUAL_ID;
				}
				break;
			case StoryPatternStoryPatternElementsCompartmentEditPart.VISUAL_ID:
				if (MlstorypatternsPackage.eINSTANCE.getStoryPatternObject().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryPatternObjectEditPart.VISUAL_ID;
				}
				if (MlstorypatternsPackage.eINSTANCE.getStoryPattern().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryPattern2EditPart.VISUAL_ID;
				}
				break;
			case StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID:
				if (MlexpressionsPackage.eINSTANCE.getMLStringExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return MLStringExpression3EditPart.VISUAL_ID;
				}
				if (MlcallactionsPackage.eINSTANCE.getCallActionExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return CallActionExpression3EditPart.VISUAL_ID;
				}
				break;
			case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
				if (MlexpressionsPackage.eINSTANCE.getMLStringExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return MLStringExpression2EditPart.VISUAL_ID;
				}
				if (MlcallactionsPackage.eINSTANCE.getCallActionExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return CallActionExpressionEditPart.VISUAL_ID;
				}
				break;
			case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
				if (MlstorypatternsPackage.eINSTANCE.getAttributeAssignment().isSuperTypeOf(domainElement.eClass()))
				{
					return AttributeAssignmentEditPart.VISUAL_ID;
				}
				break;
			case StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID:
				if (MlstorypatternsPackage.eINSTANCE.getStoryPatternObject().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryPatternObjectEditPart.VISUAL_ID;
				}
				if (MlstorypatternsPackage.eINSTANCE.getStoryPattern().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryPattern2EditPart.VISUAL_ID;
				}
				break;
			case StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID:
				if (MlexpressionsPackage.eINSTANCE.getMLStringExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return MLStringExpression3EditPart.VISUAL_ID;
				}
				if (MlcallactionsPackage.eINSTANCE.getCallActionExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return CallActionExpression3EditPart.VISUAL_ID;
				}
				break;
			case ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID:
				if (MlexpressionsPackage.eINSTANCE.getMLStringExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return MLStringExpressionEditPart.VISUAL_ID;
				}
				if (MlcallactionsPackage.eINSTANCE.getCallActionExpression().isSuperTypeOf(domainElement.eClass()))
				{
					return CallActionExpression2EditPart.VISUAL_ID;
				}
				break;
			case StoryNodeStoryNodeElementsCompartment2EditPart.VISUAL_ID:
				if (MlstorypatternsPackage.eINSTANCE.getStoryPattern().isSuperTypeOf(domainElement.eClass()))
				{
					return StoryPatternEditPart.VISUAL_ID;
				}
				break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID)
	{
		String containerModelID = de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry.getModelID(containerView);
		if (!ActivityEditPart.MODEL_ID.equals(containerModelID))
		{
			return false;
		}
		int containerVisualID;
		if (ActivityEditPart.MODEL_ID.equals(containerModelID))
		{
			containerVisualID = de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry.getVisualID(containerView);
		}
		else
		{
			if (containerView instanceof Diagram)
			{
				containerVisualID = ActivityEditPart.VISUAL_ID;
			}
			else
			{
				return false;
			}
		}
		switch (containerVisualID)
		{
			case ActivityEditPart.VISUAL_ID:
				if (ActivityFinalNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (DecisionMergeNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ExpressionActivityNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (FlowFinalNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ForkJoinNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (InitialNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StructuredNodeEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ActivityFinalNodeEditPart.VISUAL_ID:
				if (WrappingLabelEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ExpressionActivityNodeEditPart.VISUAL_ID:
				if (ExpressionActivityNodeNameEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ExpressionActivityNodeExpressionFigureCompartmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case InitialNodeEditPart.VISUAL_ID:
				if (WrappingLabel2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryNodeEditPart.VISUAL_ID:
				if (StoryNodeNameEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StructuredNodeEditPart.VISUAL_ID:
				if (DecisionMergeNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ExpressionActivityNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (FlowFinalNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ForkJoinNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (InitialNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StructuredNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ActivityFinalNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternEditPart.VISUAL_ID:
				if (StoryPatternStoryPatternElementsCompartmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternObjectEditPart.VISUAL_ID:
				if (StoryPatternObjectNameEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (WrappingLabel5EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (WrappingLabel6EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPattern2EditPart.VISUAL_ID:
				if (StoryPatternName2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ExpressionActivityNode2EditPart.VISUAL_ID:
				if (ExpressionActivityNodeName2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case InitialNode2EditPart.VISUAL_ID:
				if (WrappingLabel13EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryNode2EditPart.VISUAL_ID:
				if (StoryNodeName2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryNodeStoryNodeElementsCompartment2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StructuredNode2EditPart.VISUAL_ID:
				if (DecisionMergeNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ExpressionActivityNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (FlowFinalNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ForkJoinNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (InitialNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StructuredNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (ActivityFinalNode2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ActivityFinalNode2EditPart.VISUAL_ID:
				if (WrappingLabel3EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ExpressionActivityNodeExpressionFigureCompartmentEditPart.VISUAL_ID:
				if (MLStringExpressionEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (CallActionExpression2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID:
				if (StoryPatternEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternStoryPatternElementsCompartmentEditPart.VISUAL_ID:
				if (StoryPatternObjectEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPattern2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID:
				if (MLStringExpression3EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (CallActionExpression3EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
				if (MLStringExpression2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (CallActionExpressionEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
				if (AttributeAssignmentEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID:
				if (StoryPatternObjectEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (StoryPattern2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID:
				if (MLStringExpression3EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (CallActionExpression3EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID:
				if (MLStringExpressionEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (CallActionExpression2EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryNodeStoryNodeElementsCompartment2EditPart.VISUAL_ID:
				if (StoryPatternEditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ActivityEdgeEditPart.VISUAL_ID:
				if (WrappingLabel4EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case StoryPatternLinkEditPart.VISUAL_ID:
				if (WrappingLabel7EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (WrappingLabel8EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case ExpressionLinkEditPart.VISUAL_ID:
				if (WrappingLabel9EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case LinkOrderConstraintEditPart.VISUAL_ID:
				if (WrappingLabel15EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case MapEntryLinkEditPart.VISUAL_ID:
				if (WrappingLabel10EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				if (WrappingLabel11EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
			case MapEntryLinkValueTargetEditPart.VISUAL_ID:
				if (WrappingLabel12EditPart.VISUAL_ID == nodeVisualID)
				{
					return true;
				}
				break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement)
	{
		if (domainElement == null)
		{
			return -1;
		}
		if (MlsdmPackage.eINSTANCE.getActivityEdge().isSuperTypeOf(domainElement.eClass()))
		{
			return ActivityEdgeEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getStoryPatternLink().isSuperTypeOf(domainElement.eClass()))
		{
			return StoryPatternLinkEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getContainmentLink().isSuperTypeOf(domainElement.eClass()))
		{
			return ContainmentLinkEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getExpressionLink().isSuperTypeOf(domainElement.eClass()))
		{
			return ExpressionLinkEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getLinkOrderConstraint().isSuperTypeOf(domainElement.eClass()))
		{
			return LinkOrderConstraintEditPart.VISUAL_ID;
		}
		if (MlstorypatternsPackage.eINSTANCE.getMapEntryLink().isSuperTypeOf(domainElement.eClass()))
		{
			return MapEntryLinkEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Activity element)
	{
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView, EObject domainElement, int candidate)
	{
		if (candidate == -1)
		{
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID)
	{
		switch (visualID)
		{
			case ExpressionActivityNodeExpressionFigureCompartmentEditPart.VISUAL_ID:
			case StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID:
			case StoryPatternStoryPatternElementsCompartmentEditPart.VISUAL_ID:
			case StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID:
			case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
			case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
			case StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID:
			case StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID:
			case ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID:
			case StoryNodeStoryNodeElementsCompartment2EditPart.VISUAL_ID:
				return true;
			default:
				break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID)
	{
		switch (visualID)
		{
			case ActivityEditPart.VISUAL_ID:
				return false;
			case ActivityFinalNodeEditPart.VISUAL_ID:
			case ForkJoinNodeEditPart.VISUAL_ID:
			case InitialNodeEditPart.VISUAL_ID:
			case DecisionMergeNodeEditPart.VISUAL_ID:
			case FlowFinalNodeEditPart.VISUAL_ID:
			case MLStringExpressionEditPart.VISUAL_ID:
			case MLStringExpression2EditPart.VISUAL_ID:
			case AttributeAssignmentEditPart.VISUAL_ID:
			case DecisionMergeNode2EditPart.VISUAL_ID:
			case FlowFinalNode2EditPart.VISUAL_ID:
			case ForkJoinNode2EditPart.VISUAL_ID:
			case InitialNode2EditPart.VISUAL_ID:
			case CallActionExpressionEditPart.VISUAL_ID:
			case CallActionExpression2EditPart.VISUAL_ID:
			case MLStringExpression3EditPart.VISUAL_ID:
			case CallActionExpression3EditPart.VISUAL_ID:
			case ActivityFinalNode2EditPart.VISUAL_ID:
				return true;
			default:
				break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure	TYPED_INSTANCE	= new DiagramStructure()
															{
																/**
																 * @generated
																 */
																@Override
																public int getVisualID(View view)
																{
																	return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry
																			.getVisualID(view);
																}

																/**
																 * @generated
																 */
																@Override
																public String getModelID(View view)
																{
																	return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry
																			.getModelID(view);
																}

																/**
																 * @generated
																 */
																@Override
																public int getNodeVisualID(View containerView, EObject domainElement)
																{
																	return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry
																			.getNodeVisualID(containerView, domainElement);
																}

																/**
																 * @generated
																 */
																@Override
																public boolean checkNodeVisualID(View containerView, EObject domainElement,
																		int candidate)
																{
																	return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry
																			.checkNodeVisualID(containerView, domainElement, candidate);
																}

																/**
																 * @generated
																 */
																@Override
																public boolean isCompartmentVisualID(int visualID)
																{
																	return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry
																			.isCompartmentVisualID(visualID);
																}

																/**
																 * @generated
																 */
																@Override
																public boolean isSemanticLeafVisualID(int visualID)
																{
																	return de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry
																			.isSemanticLeafVisualID(visualID);
																}
															};

}
