package de.mdelab.mlsdm.diagram.custom.actions;

import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.ui.IObjectActionDelegate;

import de.mdelab.mlcore.ui.diagrams.CustomAbstractActionDelegate;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.diagram.custom.dialogs.CommonEditParametersDialog2;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;

public class CustomEditParametersAction2 extends CustomAbstractActionDelegate implements IObjectActionDelegate
{

	protected CommonEditParametersDialog2	editParamsDialog;

	@Override
	protected void doRun(IProgressMonitor progressMonitor)
	{
		editParamsDialog = new CommonEditParametersDialog2(null);
		editParamsDialog.setActivity((Activity) this.getInitialNode().getActivityNodeContainer().eContainer());
		editParamsDialog.setInitialNodeEditPart(this.getInitialNodeEditPart());
		editParamsDialog.open();
		this.getInitialNodeEditPart().addNotify();
		List<?> l = this.getInitialNodeEditPart().getParent().getChildren();
		for (int i = 0; i< l.size();i++){
			if (l.get(i) instanceof ActivityFinalNodeEditPart){
				((ActivityFinalNodeEditPart)l.get(i)).addNotify();
			}
		}
	}

	protected InitialNode getInitialNode()
	{
		return (InitialNode) ((View) ((InitialNode2EditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	protected InitialNode2EditPart getInitialNodeEditPart()
	{
		return (InitialNode2EditPart) getStructuredSelection().getFirstElement();
	}

}
